IMPLEMENTATION MODULE Gray;
(*  1988-2016 Ari.Tao  * 09.06.88 ~ 09.09.97 + 05.02.14 ~ 02.05.16

*)(*$T-,$S-,$Q+*)

(* Fr's mini TeDeum:
IMPORT AEI,AEB, VDB,VDW, VE, Screen;
*)
FROM   SYSTEM  IMPORT BYTE, PUSH, CODE, SETREG;
FROM   BIOX    IMPORT xBRA, SetExc,RemExc, Peek,Poke;

CONST  VBHADR = 70H; RTS = 4E75H; PUSHD0 = 2F00H; PULLD0 = 201FH;
       VSRADR = 0FF8200H; GRAY = "GRAY";

VAR    ShiftReg[VSRADR]:   AD;
       Count, Rate:        INTEGER;         (* Gedchtnis fr OnOff.*)
       Radr0,Radr1, OldR:  AD;
       xGRAY:              xBRA;

PROCEDURE Convert (VAR Adr: ARRAY (*4*) OF BYTE);  (* in's Shifter-Format.*)
 BEGIN Adr[3] := Adr[2]; Adr[2] := BYTE(0c)(* eigtl. unntig *) END Convert;

PROCEDURE Switch (OnOff: CARDINAL; aScr0,aScr1: AD);
 (* Verbiegt den Vektor 'VBI-ListHandler' & rettet das VideoShiftRegister.*)
 BEGIN IF (OnOff= 0) THEN
           RemExc (VBHADR DIV 4, GRAY, GrayCode);
           Poke   (VSRADR, OldR);
    ELSIF (Rate = 0) THEN Convert (aScr0); Radr0 := aScr0;
                          Convert (aScr1); Radr1 := aScr1;
           Peek   (VSRADR, OldR);
           SetExc (VBHADR DIV 4, GRAY, GrayCode, xGRAY); END (*I*);
    Rate:= OnOff; END Switch;

PROCEDURE GrayCode;  (*$P-*)
 BEGIN IF (Count < 0) THEN
           Count := Rate;  ShiftReg := Radr1;
    ELSIF (Count = 0) THEN ShiftReg := Radr0; END;
    DEC   (Count); (* mod Rate *)
    PUSH (xGRAY.OldVec);
    CODE (RTS);                            (* Springt 'zurck' zum OldVec.*)
    END GrayCode;    (*$P+*)

PROCEDURE Init; BEGIN Count := 0; Rate := 0; Peek (VSRADR, OldR) END Init;

(**)
BEGIN Init END Gray .

*)(*$A+*)

MODULE TESTandDEMO;
FROM   VE   IMPORT wS, GoXY;
FROM Screen IMPORT Put, Attrib, AttSet, Save,ReSt, LogA,PhyA, RaW;
FROM   VDB  IMPORT XMAX,YMAX, WMAX, MouseCursor, CURSON,CURSEX, Pause, IG;
FROM   VDB  IMPORT ClrBox;
IMPORT VDB, AD, Switch;
EXPORT TeDeum;

PROCEDURE Text0;
 BEGIN Tb (01,02); wS (" ");
       Tb (11,02); wS (" Dies ist ein Demo fr Zwischen-Farben ");
       Tb (12,03); wS ( " auf einem !_2-Farben-Schirm_! ");
       Tb (11,23); wS (" Weiter mit MausTaste! ");
       Tb (48,23); wS ("  1994-2014 Ari.Tao "); END Text0;
PROCEDURE Text1;
 BEGIN    Text0;
       Tb (32,14); wS (" 2 weitere Stufen mit ");
       Tb (37,15); wS      (" Pfeffer & Salz "); END Text1;
PROCEDURE Text;
 BEGIN    Text1;
       Tb (17,20); wS (" Kontrast oder Helligkeit etwas verringern, ");
       Tb (18,21); wS  (" wenn's noch flimmert. "); END Text;

CONST  (* Userdef. Punkt-Patterns fr PatBox: *)
       DM0100 =1; DM0010 =2; DM1110 =3; DM0111 =4; DM0110 =5; DM1001 =6;

VAR    cp,cf: IG;
       PattS: ARRAY [1..6] OF ARRAY [1..16] OF IG;

PROCEDURE  BarBox (ax,ay,bx,by, cf: IG);
   VAR p: IG;
 BEGIN p := 8;
       VDB.PatBox (ax,ay,bx,by, cf, 1,  p) END BarBox;
PROCEDURE  PatBox (ax,ay,bx,by, cp,idx, p: IG);
 BEGIN VDB.PatBox (ax,ay,bx,by, cp,idx, PattS[p]) END PatBox;

PROCEDURE PattSInit;
 VAR   k: IG;
 CONST F1 = (1+4+16+64) *(256+1); F2 = IG (F1 *2);
 BEGIN
   FOR k := 1 TO 15 BY 2 DO
     PattS [DM0100, k]   := F1;
     PattS [DM0100, k+1] :=  0;
     PattS [DM0010, k]   :=  0;
     PattS [DM0010, k+1] := F2;
     PattS [DM1110, k]   := -1;
     PattS [DM1110, k+1] := F1;
     PattS [DM0111, k]   := F2;
     PattS [DM0111, k+1] := -1;
     PattS [DM0110, k]   := F1;
     PattS [DM0110, k+1] := F2;
     PattS [DM1001, k]   := F2;
     PattS [DM1001, k+1] := F1;
     END (*k*); END PattSInit;

PROCEDURE Tb (h, v: CARDINAL); BEGIN GoXY (h+1, v+1) END Tb; (* Tabulator.*)
PROCEDURE gMouseOn;  BEGIN MouseCursor (CURSON) END gMouseOn;
PROCEDURE gMouseOff; BEGIN MouseCursor (CURSEX) END gMouseOff;

PROCEDURE FillWords (adr: AD; bpl, W,H, fill: CARDINAL);
   VAR w:  CARDINAL;  ptr: POINTER TO CARDINAL;            (*$T- Ptr.INC! *)
 BEGIN WHILE H > 0 DO ptr := adr; INC (adr, bpl); DEC (H);
        FOR w := 1 TO W DO ptr^ := fill; INC (ptr, 2) END END (*H*); (*$T=*)
   END FillWords;

PROCEDURE Set (i: CARDINAL);               (* Auswahl des aktiven Screens.*)
 BEGIN Put (i, AttSet {phys, log, act}) END Set;

VAR    BPL: INTEGER;                              (* Bytes pro Scan-Zeile.*)

VAR aL1,aL2, aP1,aP2: AD;

PROCEDURE DoTest (k: IG);
   VAR s: ARRAY [0..2] OF CHAR;
 BEGIN Tb (1, 2); s := " "; s[0] := CHR (30H+k); wS (s) (* TestID li.o.*);
   gMouseOn;
   IF k = 2 THEN Switch (2, aP1,aP2) ELSE Switch (1, aP1,aP2) END;
   Pause;        Switch (0, 0, 0);
   gMouseOff; END DoTest;


PROCEDURE TeDeum;
   VAR k: IG;
 BEGIN aL1 := LogA (1); aL2 := LogA (2);
       aP1 := PhyA (1); aP2 := PhyA (2);
   gMouseOff;

   Set (1); PatBox (  0, 20, 639(*XMAX*),399(*YMAX*), cp, 4, DM1001); Text0;
            Save;  (* ^--area in 1 totally gray with pattern below menue. *)
   Set (2); ReSt;  (* <--area in 2 the same. Now some crossed rectangles: *)
            BarBox (160, 50,479,149, cf);
            ClrBox (160,250,479,349);     Pause;
   Set (1); ClrBox (240,100,319,299);
            BarBox (320,100,399,299, cf); Pause;
(*
   FOR k := 0 TO 124 DO        (* Interleaving a la TV alias Flimmerkiste *)
     FillWords (aL2+ AD (10+ (50+k*2)*BPL), BPL, 10,1, 0);
     FillWords (aL2+ AD (10+ (51+k*2)*BPL), BPL, 10,1, 0FFFFH);
     FillWords (aL1+ AD (10+(100+k*2)*BPL), BPL, 10,1, 0FFFFH);
     FillWords (aL1+ AD (10+(101+k*2)*BPL), BPL, 10,1, 0);
     END (*k*);       (* In Farbe macht dies allerdings blo Flecken li.o.*)
*)
   (* Some more crossed rectangles, patterned: *)
   Set (2); PatBox (400, 50,559,299, cp, 4, DM0110);
   Set (1); PatBox (400,100,559,299, cp, 4, DM1001);
   (* Fr das neue, leckere Grau: 'auf Lcke' mit Pfeffer & Salz versetzt *)
   DoTest (1);  (* flackert etwas  *)
   DoTest (2);  (* flackert heftig *)

   (* Und jetzt etwas schlauer: *)
   Set (2); PatBox ( 80, 50,559,349, cp, 4, DM0110); (* peps o/o *)
            ClrBox (240,200,319,299);                    (* wei *)
            BarBox (320,200,399,299, cf);                (* voll *)
   Set (1); PatBox ( 80, 50,559,349, cp, 4, DM1001); (* peps o\o *)
            ClrBox (240,200,319,299);                    (* wei *)
            BarBox (320,200,399,299, cf);                (* voll *)

   (* Plus 2 weitere Stufen, bei halber Auflsung: *)
            BarBox (240,100,319,199, cf);                (* voll *)
            ClrBox (320,100,399,199);                    (* wei *)

   Text1; Set (2);
   Text1; Set (1);
   DoTest (3);  (* flimmert noch *)

   (* & jetzt noch die letzten Feinheiten: *)
   Set (2); PatBox (240,100,319,199, cp, 4, DM1110);
            PatBox (320,100,399,199, cp, 4, DM0100);
   Set (1); PatBox (240,100,319,199, cp, 4, DM0111);
            PatBox (320,100,399,199, cp, 4, DM0010);

   Text; Set (2);
   Text; Set (1);
   DoTest (4);  (* perfekt! *)

   gMouseOn; END TeDeum;

PROCEDURE Cite (VAR s: ARRAY OF CHAR); END Cite;

BEGIN (*I*) BPL := RaW (); cp := VDB.LGREEN; cf := cp; PattSInit;
   Cite (" *******************  2014 @ ******************* ");
   Cite (" ************************************************ ");
   END (*M*) TESTandDEMO;

BEGIN Init;
      AEB.WindSem (AEB.OWN);
      VE.Init (VDB.gDEV);
   TeDeum;
   Screen.End;
   AEB.WindSem (AEB.CLR);
   AEB.DeskRefresh;
   END Gray .
