IMPLEMENTATION MODULE Gray;
(*  1988-2014 Ari.Tao  * 09.06.88 ~ 09.09.97 + 05.02.14 *)
(*$T-,$S-,$Q+ *)
(* Fr's TeDeum (mit Mini linken!):
IMPORT AEI,AEB, VDB, VD1, VE, Screen;
*)
FROM   SYSTEM  IMPORT BYTE, PUSH, CODE, SETREG;
FROM   BIOX    IMPORT xBRA, SetExc,RemExc, Peek,Poke;

CONST  VBHADR = 70H; RTS = 4E75H; PUSHD0 = 2F00H; PULLD0 = 201FH;
       VSRADR = 0FF8200H; GRAY = "GRAY";

VAR    ShiftReg[VSRADR]:   AD;
       Count, Rate:        INTEGER;               (* Gedchtnis fr OnOff.*)
       Radr0,Radr1, OldR:  AD;
       xGRAY:              xBRA;

PROCEDURE Convert (VAR Adr: ARRAY (*4*) OF BYTE);  (* in's Shifter-Format.*)
 BEGIN Adr[3] := Adr[2]; Adr[2] := BYTE(0c)(* eigtl. unntig *) END Convert;

PROCEDURE Switch (OnOff: CARDINAL; aScr0,aScr1: AD);
 (* Verbiegt den Vektor 'VBI-List-Handler' & rettet das VideoShiftRegister*)
 BEGIN IF (OnOff= 0) THEN
           RemExc (VBHADR DIV 4, GRAY, GrayCode);
           Poke   (VSRADR, OldR);
    ELSIF (Rate = 0) THEN Convert (aScr0); Radr0 := aScr0;
                          Convert (aScr1); Radr1 := aScr1;
           Peek   (VSRADR, OldR);
           SetExc (VBHADR DIV 4, GRAY, GrayCode, xGRAY); END (*I*);
    Rate:= OnOff; END Switch;

PROCEDURE GrayCode;  (*$P-*)
 BEGIN IF (Count < 0) THEN
           Count := Rate;  ShiftReg := Radr1;
    ELSIF (Count = 0) THEN ShiftReg := Radr0; END;
    DEC   (Count); (* mod Rate *)
    PUSH (xGRAY.OldVec);
    CODE (RTS);                            (* Springt 'zurck' zum OldVec.*)
    END GrayCode;    (*$P+*)

PROCEDURE Init; BEGIN Count := 0; Rate := 0; Peek (VSRADR, OldR) END Init;

(**)
BEGIN Init END Gray .
*)

MODULE TESTandDEMO;
FROM   VE   IMPORT wS, GoXY;
FROM Screen IMPORT Put, Attrib, AttSet, ModBox, Save,ReSt, LogA,PhyA, RaW;
FROM   VDB  IMPORT XMAX,YMAX, WMAX, MouseCursor, CURSON,CURSEX, Pause;
FROM   VD1  IMPORT PatBox;
IMPORT AD, Switch;
EXPORT TeDeum;

PROCEDURE Text0;
 BEGIN Tb (01,02); wS (" ");
       Tb (11,02); wS (" Dies Prg. ist ein Demo fr einen !_s/w-Schirm_! ");
       Tb (11,23); wS (" Weiter mit Taste! ");
       Tb (48,23); wS ("  1994-2014 Ari.Tao "); END Text0;
PROCEDURE Text1;
 BEGIN    Text0;
       Tb (32,14); wS (" 2 weitere Graustufen mit ");
       Tb (37,15); wS      (" Pfeffer & Salz "); END Text1;
PROCEDURE Text;
 BEGIN    Text1;
       Tb (17,20); wS (" Kontrast oder Helligkeit etwas verringern, ");
       Tb (18,21); wS  (" wenn's noch flimmert. "); END Text;

PROCEDURE Tb (h, v: CARDINAL); BEGIN GoXY (h+1, v+1) END Tb; (* Tabulator.*)
PROCEDURE gMouseOn;  BEGIN MouseCursor (CURSON) END gMouseOn;
PROCEDURE gMouseOff; BEGIN MouseCursor (CURSEX) END gMouseOff;

PROCEDURE FillWords (adr: AD; bpl, W,H, fill: CARDINAL);
VAR   w:  CARDINAL;  ptr: POINTER TO CARDINAL;          (*$T- fr Ptr-INC.*)
BEGIN WHILE H > 0 DO ptr := adr; INC (adr, bpl); DEC (H);
        FOR w := 1 TO W DO ptr^ := fill; INC (ptr, 2) END END (*H*); (*$T=*)
  END FillWords;

PROCEDURE Set (i: CARDINAL);               (* Auswahl des aktiven Screens.*)
 BEGIN Put (i, AttSet {phys, log, act}) END Set;

CONST  (* Userdef. Punkt-Patterns fr PatBox: *)
       DM0100 =1; DM0010 =2; DM1110 =3; DM0111 =4; DM0110 =5; DM1001 =6;

VAR    BPL: INTEGER;                              (* Bytes pro Scan-Zeile.*)

VAR aL1,aL2, aP1,aP2: AD;

PROCEDURE DoTest (k: CARDINAL);
   VAR s: ARRAY [0..2] OF CHAR;
 BEGIN Tb (1, 2); s := " "; s[0] := CHR (30H+k); wS (s); (* TestID li.o.*)
   gMouseOn;
   IF k = 2 THEN Switch (2, aP1,aP2) ELSE Switch (1, aP1,aP2) END;
   Pause;        Switch (0, 0, 0);
   gMouseOff; END DoTest;


PROCEDURE TeDeum;
 VAR   k: INTEGER;
 BEGIN aL1 := LogA (1); aL2 := LogA (2);
       aP1 := PhyA (1); aP2 := PhyA (2);
   gMouseOff;

   Set (1); PatBox (  0, 20, 639(*XMAX*),399(*YMAX*), 1, 4, DM1001); Text0;
            Save;  (* ^--area in 1 totally gray with pattern below menue. *)
   Set (2); ReSt;  (* <--area in 2 the same. Now some crossed rectangles: *)
            ModBox (160, 50,479,149, 15);
            ModBox (160,250,479,349,  0); Pause;
   Set (1); ModBox (240,100,319,299,  0);
            ModBox (320,100,399,299, 15); Pause;
(*
   FOR k := 0 TO 124 DO        (* Interleaving a la TV alias Flimmerkiste *)
       FillWords (aL2+ AD (10+ (50+k*2)*BPL), BPL, 10,1, 0);
       FillWords (aL2+ AD (10+ (51+k*2)*BPL), BPL, 10,1, 0FFFFH);
       FillWords (aL1+ AD (10+(100+k*2)*BPL), BPL, 10,1, 0FFFFH);
       FillWords (aL1+ AD (10+(101+k*2)*BPL), BPL, 10,1, 0);
       END (*k*);     (* In Farbe macht dies allerdings blo Flecken li.o.*)
*)
   (* Some more crossed rectangles, patterned: *)
   Set (2); PatBox (400, 50,559,299, 1, 4, DM0110);
   Set (1); PatBox (400,100,559,299, 1, 4, DM1001);
   (* Fr das neue, leckere Grau: 'auf Lcke' mit Pfeffer & Salz versetzt *)
   DoTest (1);  (* flackert etwas  *)
   DoTest (2);  (* flackert heftig *)

   (* Und jetzt etwas schlauer: *)
   Set (2); PatBox ( 80, 50,559,349, 1, 4, DM0110);           (* peps o/o *)
            ModBox (240,200,319,299,  0);                     (* wei *)
            ModBox (320,200,399,299, 15);                     (* schwarz  *)
   Set (1); PatBox ( 80, 50,559,349, 1, 4, DM1001);           (* peps o\o *)
            ModBox (240,200,319,299,  0);                     (* wei *)
            ModBox (320,200,399,299, 15);                     (* schwarz  *)

   (* Plus 2 weitere Graustufen, bei halber Auflsung: *)
            ModBox (240,100,319,199, 15);                     (* schwarz  *)
            ModBox (320,100,399,199,  0);                     (* wei *)

   Text1; Set (2);
   Text1; Set (1);
   DoTest (3);  (* flimmert noch *)

   (* ...und jetzt noch die letzten Feinheiten: *)
   Set (2); PatBox (240,100,319,199, 1, 4, DM1110);
            PatBox (320,100,399,199, 1, 4, DM0100);
   Set (1); PatBox (240,100,319,199, 1, 4, DM0111);
            PatBox (320,100,399,199, 1, 4, DM0010);

   Text; Set (2);
   Text; Set (1);
   DoTest (4);  (* perfekt! *)

   gMouseOn; END TeDeum;

BEGIN (*I*) BPL := RaW ();
  END (*M*) TESTandDEMO;

BEGIN Init;
      AEB.WindSem (AEB.OWN);
      VDB.GDEV := AEB.GrafHandle ();
      VE.Init (VDB.gDEV);
   TeDeum;
   Screen.End;
   VD1.CloseVW;
   AEB.WindSem (AEB.CLR);
   AEB.DeskRefresh;
   END Gray .        .
